
       IDENTIFICATION DIVISION.
       PROGRAM-ID. DATENTRY.

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. PC.
       OBJECT-COMPUTER. PC.

       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY "CUSTOMER.SEL".
       DATA DIVISION.
       FILE SECTION.
           COPY "CUSTOMER.FD".
       WORKING-STORAGE SECTION.
       01 VF-LIMIT.
          02 VF-ELE                     PIC X(24)
                        VALUE "312931303130313130313031".
 
       01 VF-TOPE REDEFINES VF-LIMIT.
          02 VF-T   OCCURS 12 TIMES     PIC 99.
 
       01 X-DATE.
           03 DX                        PIC 99.
           03 FILLER                    PIC X VALUE "/".
           03 MX                        PIC 99.
           03 FILLER                    PIC X VALUE "/".
           03 AX                        PIC 99.
 
       01 W-DATE.
          03 AW                         PIC 99.
          03 MW                         PIC 99.
          03 DW                         PIC 99.

       01 W-NUMBER                      PIC S9(12)V9(6).
       01 W-INTEGER                     PIC 9(12).
       01 WORKING-FIELDS.
           02 CUS-NUMBER-T  PIC 999999.
           02 CUS-NUMBER-D  PIC 999999.
           02 CUS-NAME-1-T  PIC XXXXXXXXXXXXXXXXXX.
           02 CUS-NAME-1-D  PIC XXXXXXXXXXXXXXXXXX.
           02 CUS-NAME-2-T  PIC XXXXXXXXXXXXXXXXX.
           02 CUS-NAME-2-D  PIC XXXXXXXXXXXXXXXXX.
           02 CUS-COMPANY-T  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-COMPANY-D  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-ADDRESS-1-T  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-ADDRESS-1-D  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-ADDRESS-2-T  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-ADDRESS-2-D  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-CITY-T  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-CITY-D  PIC XXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-STATE-T  PIC XX.
           02 CUS-STATE-D  PIC XX.
           02 CUS-ZIP-T  PIC 99999.
           02 CUS-ZIP-D  PIC 99999.
           02 CUS-PHONE-T  PIC XXXXXXXXXXXXXXXXX.
           02 CUS-PHONE-D  PIC XXXXXXXXXXXXXXXXX.
           02 CUS-EMAIL-T  PIC XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX.
           02 CUS-EMAIL-D  PIC XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX.
           02 W-STATE                   PIC X.
           02 W-MODE                    PIC X   VALUE "A".
           02 W-DUMMY                   PIC X.
           02 CONT                      PIC 99  VALUE 1.
           02 DATE-EDITED.
              03 FILLER                 PIC XXXXXXX.
              03 W-DAY                  PIC 99.
              03 FILLER                 PIC X   VALUE "/".
              03 W-MONTH                PIC 99.
              03 FILLER                 PIC X   VALUE "/".
              03 W-YEAR                 PIC 99.
              03 FILLER                 PIC XXXXX.
           02 SYS-DATE.
              03 W-YEAR-SIS             PIC 99.
              03 W-MONTH-SIS            PIC 99.
              03 W-DAY-SIS              PIC 99.
           02 ED-DATE-TMP               PIC 99/99/99.
           02 DATE-TMP                  PIC 9(6).   
           02 CONT-OP                   PIC 9   VALUE 1.
           02 IND-DATE                  PIC 9.
              88 SI-DATE                        VALUE 0.
              88 NO-DATE                        VALUE 1.
           02 IND-ERR                   PIC 9.
              88 NO-ERROR                       VALUE 0.
              88 YES-ERROR                      VALUE 1.
           02 IND-ENTER                 PIC 9.
              88 NO-ENTER                       VALUE 0.
              88 END-ENTER                      VALUE 1.
           02 W-OPTION                  PIC X.
              88 W-FIRST                        VALUE "F" "f".
              88 W-NEXT                         VALUE "N" "n".
              88 W-ADD                          VALUE "A" "a".
              88 W-UPDATE                       VALUE "M" "m".
              88 W-DELETE                       VALUE "D" "d".
              88 W-QUERY                        VALUE "Q" "q".
              88 W-END                          VALUE "E" "e".
              
           02 FS-CUSTOMERS                    PIC XX  VALUE "00".
           02 ERROR-CODE REDEFINES FS-CUSTOMERS
                                        PIC 99.
              88 NO-RECORD-FOUND                VALUE 23.
              88 NO-FILE-FOUND                  VALUE 35 94.
              88 RECORD-IN-USE                  VALUE 99.
              88 LAST-RECORD                    VALUE 10.
              88 NOTHING                        VALUE 00.

           02 KEY-VALUE                 PIC 9999.
                 88 KTAB                        VALUE 09.
                 88 KEY-UP                      VALUE 52.
                 88 KEY-DOWN                    VALUE 53.
                 88 ESC                         VALUE 27 41 07. 
                 88 F1                          VALUE 01.
                 88 F2                          VALUE 02.
                 88 F3                          VALUE 03.
                 88 F4                          VALUE 04.
                 88 F5                          VALUE 05.
                 88 F6                          VALUE 06.
                 88 F7                          VALUE 07.
                 88 F8                          VALUE 08.
                 88 F10                         VALUE 10.
                 88 PUP                         VALUE 67.
                 88 PDW                         VALUE 68.
                 88 ENTERK                      VALUE 13.

       PROCEDURE DIVISION.
       DECLARATIVES.
       PART-1 SECTION.
           USE AFTER STANDARD ERROR PROCEDURE
                     ON CUSTOMERS.
       END DECLARATIVES.                                                 
       NORMAL SECTION.                                                   
       P-BEGIN.                                                          
           OPEN I-O  CUSTOMERS
           IF NO-FILE-FOUND
                 DISPLAY 
           "File CUSTOMERS does not exist, Create it? (Y/N)?"
                 LINE 1  ERASE
                 ACCEPT W-DUMMY POSITION 0 TAB 
                 IF W-DUMMY = "Y" OR W-DUMMY = "y"
                        OPEN OUTPUT CUSTOMERS
                        CLOSE CUSTOMERS
                        OPEN I-O CUSTOMERS
                   ELSE
                        DISPLAY " " ERASE
                        GO P-OUT-PROGRAM                        
           ELSE
                 IF ERROR-CODE > 0
                    DISPLAY
                  "File Error Detected - Status : " FS-CUSTOMERS
                    ACCEPT W-DUMMY POSITION 0
                    GO P-OUT-PROGRAM.
                 
           ACCEPT SYS-DATE FROM DATE
                  MOVE W-YEAR-SIS TO W-YEAR
                  MOVE W-MONTH-SIS TO W-MONTH
                  MOVE W-DAY-SIS TO W-DAY

           PERFORM DISPLAY-SCREEN                                              
           MOVE SPACES TO W-OPTION
           DISPLAY DATE-EDITED LINE 2 POSITION 57 LOW
          
           PERFORM PROCESS UNTIL W-END

           CLOSE CUSTOMERS.
       
       P-OUT-PROGRAM.
      *    EXIT PROGRAM.
           STOP RUN.

       PROCESS.
           ACCEPT W-OPTION LINE 25 POSITION 76 NO BEEP
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
                  
           IF ESC MOVE "E" TO W-OPTION.
           MOVE 0 TO IND-ERR IND-ENTER
           
           IF W-ADD PERFORM P-ADD UNTIL END-ENTER
              ELSE
               IF W-UPDATE PERFORM P-UPDATE UNTIL END-ENTER
                 ELSE
                   IF W-DELETE PERFORM P-DELETE UNTIL END-ENTER
                     ELSE
                      IF W-QUERY PERFORM P-QUERY UNTIL END-ENTER.
           IF W-FIRST
              PERFORM P-READ-FIRST.
           IF W-NEXT               
              PERFORM P-READ-NEXT.
         
       P-READ-FIRST.
           DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
           MOVE SPACES TO CUSTOMERS-REC
           START CUSTOMERS KEY NOT LESS CUS-NUMBER
                 INVALID KEY  MOVE 1 TO IND-ERR.
           IF NO-ERROR
              READ CUSTOMERS NEXT AT END
                   MOVE 1 TO IND-ERR
                   DISPLAY "**NO RECORDS IN FILE" LINE 24 POSITION 1.
           IF NO-ERROR
              UNLOCK CUSTOMERS
              PERFORM P-DISPLAY-DATA
            ELSE
              DISPLAY "**NO RECORDS IN FILE" LINE 24 POSITION 1.

       P-READ-NEXT.
           DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
           READ CUSTOMERS INVALID KEY MOVE 1 TO IND-ERR.
           IF NO-ERROR
              READ CUSTOMERS NEXT AT END MOVE 1 TO IND-ERR
                        DISPLAY "**END OF FILE"
                                 LINE 24 POSITION 1 BLINK.
           IF NO-ERROR
              UNLOCK CUSTOMERS
              PERFORM P-DISPLAY-DATA.
                                       
       P-ADD.
           PERFORM P-BLANK-RECORD
           PERFORM P-GET-CUS-NUMBER THRU P-END-GET
           IF NO-ERROR AND NO-ENTER 
              PERFORM P-UPDATE-MIRROR-FIELDS
              WRITE CUSTOMERS-REC INVALID KEY
                        DISPLAY "**RECORD ALREADY IN FILE"
                                LINE 24 POSITION 1 BLINK.
       P-UPDATE.
           PERFORM P-GET-CUS-NUMBER THRU P-END-GET
           IF NO-ERROR AND NO-ENTER
              REWRITE CUSTOMERS-REC INVALID KEY DISPLAY
                          "**REWRITE ERROR".
           IF NO-ERROR
              PERFORM P-UPDATE-MIRROR-FIELDS
              UNLOCK CUSTOMERS.     
                
       P-DELETE.
           PERFORM P-GET-CUS-NUMBER THRU P-END-GET 
           IF NO-ERROR AND NO-ENTER
              DISPLAY "DELETE (Y/N)?" LINE 24 POSITION 1
              ACCEPT W-DUMMY POSITION 0 
              IF W-DUMMY = "Y" OR W-DUMMY = "y"
                 DELETE CUSTOMERS INVALID KEY
                            DISPLAY "**DELETE FAIL".
           IF NO-ERROR
              PERFORM P-BLANK-RECORD
              PERFORM P-CLEAR-SCREEN.
                
       P-QUERY.
           PERFORM P-GET-CUS-NUMBER THRU P-END-GET .
           IF NO-ERROR
              UNLOCK CUSTOMERS.
              
       P-UPDATE-MIRROR-FIELDS.
           MOVE CUS-NUMBER TO CUS-NUMBER-D.
           MOVE CUS-NAME-1 TO CUS-NAME-1-D.
           MOVE CUS-NAME-2 TO CUS-NAME-2-D.
           MOVE CUS-COMPANY TO CUS-COMPANY-D.
           MOVE CUS-ADDRESS-1 TO CUS-ADDRESS-1-D.
           MOVE CUS-ADDRESS-2 TO CUS-ADDRESS-2-D.
           MOVE CUS-CITY TO CUS-CITY-D.
           MOVE CUS-STATE TO CUS-STATE-D.
           MOVE CUS-ZIP TO CUS-ZIP-D.
           MOVE CUS-PHONE TO CUS-PHONE-D.
           MOVE CUS-EMAIL TO CUS-EMAIL-D.

       P-GET-CUS-NUMBER.
           MOVE CUS-NUMBER TO CUS-NUMBER-T
           DISPLAY CUS-NUMBER-T LINE  9 POSITION  23 REVERSE
           ACCEPT CUS-NUMBER LINE  9 POSITION  23 REVERSE NO BEEP
                  UPDATE CONVERT TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-NUMBER-D TO CUS-NUMBER.       
            MOVE CUS-NUMBER TO CUS-NUMBER-T
            DISPLAY CUS-NUMBER-T LINE  9 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-0.
            
      ***** VALIDATE
            IF CUS-NUMBER IS EQUAL ZEROS
               GO P-GET-CUS-NUMBER.
      ***** END-VALIDATE
      
            PERFORM P-CLEAR-SCREEN
            PERFORM P-PROCESS-RECORD.
            IF W-ADD
               PERFORM P-BLANK-RECORD.      
            IF F1
               PERFORM P-PROCESS-RECORD
               MOVE 0 TO KEY-VALUE.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-NAME-1.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-NAME-1.
           MOVE CUS-NAME-1 TO CUS-NAME-1-T
           DISPLAY CUS-NAME-1-T LINE  10 POSITION  23 REVERSE
           ACCEPT CUS-NAME-1 LINE  10 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-NAME-1-D TO CUS-NAME-1.       
            MOVE CUS-NAME-1 TO CUS-NAME-1-T
            DISPLAY CUS-NAME-1-T LINE  10 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-NUMBER.
            
      ***** VALIDATE
            IF CUS-NAME-1 IS EQUAL SPACES
               GO P-GET-CUS-NAME-1.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-NAME-2.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-NAME-2.
           MOVE CUS-NAME-2 TO CUS-NAME-2-T
           DISPLAY CUS-NAME-2-T LINE  10 POSITION  45 REVERSE
           ACCEPT CUS-NAME-2 LINE  10 POSITION  45 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-NAME-2-D TO CUS-NAME-2.       
            MOVE CUS-NAME-2 TO CUS-NAME-2-T
            DISPLAY CUS-NAME-2-T LINE  10 POSITION  45 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-NAME-1.
            
      ***** VALIDATE
            IF CUS-NAME-2 IS EQUAL SPACES
               GO P-GET-CUS-NAME-2.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-COMPANY.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-COMPANY.
           MOVE CUS-COMPANY TO CUS-COMPANY-T
           DISPLAY CUS-COMPANY-T LINE  11 POSITION  23 REVERSE
           ACCEPT CUS-COMPANY LINE  11 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-COMPANY-D TO CUS-COMPANY.       
            MOVE CUS-COMPANY TO CUS-COMPANY-T
            DISPLAY CUS-COMPANY-T LINE  11 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-NAME-2.
            
      ***** VALIDATE
            IF CUS-COMPANY IS EQUAL SPACES
               GO P-GET-CUS-COMPANY.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-ADDRESS-1.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-ADDRESS-1.
           MOVE CUS-ADDRESS-1 TO CUS-ADDRESS-1-T
           DISPLAY CUS-ADDRESS-1-T LINE  12 POSITION  23 REVERSE
           ACCEPT CUS-ADDRESS-1 LINE  12 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-ADDRESS-1-D TO CUS-ADDRESS-1.       
            MOVE CUS-ADDRESS-1 TO CUS-ADDRESS-1-T
            DISPLAY CUS-ADDRESS-1-T LINE  12 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-COMPANY.
            
      ***** VALIDATE
            IF CUS-ADDRESS-1 IS EQUAL SPACES
               GO P-GET-CUS-ADDRESS-1.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-ADDRESS-2.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-ADDRESS-2.
           MOVE CUS-ADDRESS-2 TO CUS-ADDRESS-2-T
           DISPLAY CUS-ADDRESS-2-T LINE  13 POSITION  23 REVERSE
           ACCEPT CUS-ADDRESS-2 LINE  13 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-ADDRESS-2-D TO CUS-ADDRESS-2.       
            MOVE CUS-ADDRESS-2 TO CUS-ADDRESS-2-T
            DISPLAY CUS-ADDRESS-2-T LINE  13 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-ADDRESS-1.
            
      ***** VALIDATE
            IF CUS-ADDRESS-2 IS EQUAL SPACES
               GO P-GET-CUS-ADDRESS-2.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-CITY.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-CITY.
           MOVE CUS-CITY TO CUS-CITY-T
           DISPLAY CUS-CITY-T LINE  14 POSITION  23 REVERSE
           ACCEPT CUS-CITY LINE  14 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-CITY-D TO CUS-CITY.       
            MOVE CUS-CITY TO CUS-CITY-T
            DISPLAY CUS-CITY-T LINE  14 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-ADDRESS-2.
            
      ***** VALIDATE
            IF CUS-CITY IS EQUAL SPACES
               GO P-GET-CUS-CITY.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-STATE.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-STATE.
           MOVE CUS-STATE TO CUS-STATE-T
           DISPLAY CUS-STATE-T LINE  15 POSITION  23 REVERSE
           ACCEPT CUS-STATE LINE  15 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-STATE-D TO CUS-STATE.       
            MOVE CUS-STATE TO CUS-STATE-T
            DISPLAY CUS-STATE-T LINE  15 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-CITY.
            
      ***** VALIDATE
            IF CUS-STATE IS EQUAL SPACES
               GO P-GET-CUS-STATE.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-ZIP.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-ZIP.
           MOVE CUS-ZIP TO CUS-ZIP-T
           DISPLAY CUS-ZIP-T LINE  15 POSITION  44 REVERSE
           ACCEPT CUS-ZIP LINE  15 POSITION  44 REVERSE NO BEEP
                  UPDATE CONVERT TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-ZIP-D TO CUS-ZIP.       
            MOVE CUS-ZIP TO CUS-ZIP-T
            DISPLAY CUS-ZIP-T LINE  15 POSITION  44 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-STATE.
            
      ***** VALIDATE
            IF CUS-ZIP IS EQUAL ZEROS
               GO P-GET-CUS-ZIP.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-PHONE.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-PHONE.
           MOVE CUS-PHONE TO CUS-PHONE-T
           DISPLAY CUS-PHONE-T LINE  16 POSITION  23 REVERSE
           ACCEPT CUS-PHONE LINE  16 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-PHONE-D TO CUS-PHONE.       
            MOVE CUS-PHONE TO CUS-PHONE-T
            DISPLAY CUS-PHONE-T LINE  16 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-ZIP.
            
      ***** VALIDATE
            IF CUS-PHONE IS EQUAL SPACES
               GO P-GET-CUS-PHONE.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-CUS-EMAIL.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
       P-GET-CUS-EMAIL.
           MOVE CUS-EMAIL TO CUS-EMAIL-T
           DISPLAY CUS-EMAIL-T LINE  17 POSITION  23 REVERSE
           ACCEPT CUS-EMAIL LINE  17 POSITION  23 REVERSE NO BEEP
                  UPDATE  TAB 
                  ON EXCEPTION KEY-VALUE MOVE SPACES TO W-DUMMY.
            IF F3 
               MOVE CUS-EMAIL-D TO CUS-EMAIL.       
            MOVE CUS-EMAIL TO CUS-EMAIL-T
            DISPLAY CUS-EMAIL-T LINE  17 POSITION  23 LOW
            IF ESC
               MOVE 1 TO IND-ENTER  
               GO P-END-GET.
            IF KEY-UP
               GO P-GET-CUS-PHONE.
            
      ***** VALIDATE
            IF CUS-EMAIL IS EQUAL SPACES
               GO P-GET-CUS-EMAIL.
      ***** END-VALIDATE
      
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
            IF KEY-DOWN
               GO P-GET-0.
            IF F1        
               GO P-GENERAL-VALIDATION.
            DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
      *P-GET-. 
      ************** DATE FIELD ENTRY
      *     MOVE  TO W-DATE
      *     COMPUTE ED-DATE-TMP = DW * 10000 + MW * 100 + AW
      *     ACCEPT ED-DATE-TMP LINE  POSITION  REVERSE NO BEEP
      *        UPDATE SIZE 8  TAB ON EXCEPTION KEY-VALUE 
      *                   MOVE SPACES TO W-DUMMY.
      *     MOVE ED-DATE-TMP TO X-DATE
      *     COMPUTE  = AX * 10000 + MX * 100 + DX
      *     DISPLAY ED-DATE-TMP LINE  POSITION  LOW
      *     MOVE  TO DATE-TMP
      *     PERFORM P-VALIDATE-DATE
      *     IF ESC
      *       MOVE 1 TO IND-ENTER  
      *       GO P-END-GET.
      *     IF NO-DATE 
      *       GO P-GET-.
      *     IF KEY-UP
      *       GO P-GET-.
      *     IF F1        
      *       GO P-GENERAL-VALIDATION.
      *     DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
      **************DATE


       P-GET-0.

       P-GENERAL-VALIDATION.
           IF CUS-NUMBER IS EQUAL ZEROS AND W-ADD
              GO P-GET-CUS-NUMBER.
           IF CUS-NAME-1 IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-NAME-1.
           IF CUS-NAME-2 IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-NAME-2.
           IF CUS-COMPANY IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-COMPANY.
           IF CUS-ADDRESS-1 IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-ADDRESS-1.
           IF CUS-ADDRESS-2 IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-ADDRESS-2.
           IF CUS-CITY IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-CITY.
           IF CUS-STATE IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-STATE.
           IF CUS-ZIP IS EQUAL ZEROS AND W-ADD
              GO P-GET-CUS-ZIP.
           IF CUS-PHONE IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-PHONE.
           IF CUS-EMAIL IS EQUAL SPACES AND W-ADD
              GO P-GET-CUS-EMAIL.
       
       P-END-GET.
           IF ESC UNLOCK CUSTOMERS.
           
       P-PROCESS-RECORD.                           
           DISPLAY ALL SPACES SIZE 80 LINE 24 POSITION 1.
           MOVE 1 TO IND-ERR
           READ CUSTOMERS
           IF NO-RECORD-FOUND AND W-ADD
              MOVE 0 TO IND-ERR.
           IF RECORD-IN-USE
              DISPLAY "**RECORD LOCKED" LINE 24 POSITION 1 BLINK
              GO P-END-GET.
           IF NOTHING AND W-ADD
              DISPLAY "**RECORD ALREADY EXISTS"
                         LINE 24 POSITION 1 BLINK
              GO P-END-GET.
           IF W-QUERY OR W-UPDATE OR W-DELETE
              MOVE 0 TO IND-ERR
              IF NO-RECORD-FOUND
                 MOVE 1 TO IND-ERR
                 DISPLAY "**RECORD DOES NOT EXISTS" 
                            LINE 24 POSITION 1 BLINK.
           IF NO-ERROR AND NOT W-ADD AND NOT W-UPDATE
              PERFORM P-CLEAR-SCREEN
              PERFORM P-DISPLAY-DATA
              GO P-END-GET.

           IF    W-QUERY OR W-DELETE
              OR (W-UPDATE AND YES-ERROR)
                 GO P-END-GET.

           IF NO-ERROR AND W-UPDATE
              PERFORM P-DISPLAY-DATA.           
                
       P-VALIDATE-DATE.  
           MOVE 0 TO IND-DATE
           IF DATE-TMP  > 0
              MOVE DATE-TMP TO W-DATE
              COMPUTE ED-DATE-TMP = DW * 10000 + MW * 100 + AW
              MOVE ED-DATE-TMP TO X-DATE
              COMPUTE W-NUMBER = AX / 4
              COMPUTE W-INTEGER = AX / 4
              IF MX > 12 OR MX = 0 OR DX = 0 OR VF-T(MX) < DX
                 OR (MX = 2 AND W-NUMBER NOT = W-INTEGER AND DX > 28)
                 DISPLAY "* Incorrect Date" LINE 24 POSITION 1
                 MOVE 1 TO IND-DATE.
                
       P-BLANK-RECORD.
           MOVE SPACES TO CUS-NAME-1.
           MOVE SPACES TO CUS-NAME-2.
           MOVE SPACES TO CUS-COMPANY.
           MOVE SPACES TO CUS-ADDRESS-1.
           MOVE SPACES TO CUS-ADDRESS-2.
           MOVE SPACES TO CUS-CITY.
           MOVE SPACES TO CUS-STATE.
           MOVE ZEROS TO CUS-ZIP.
           MOVE SPACES TO CUS-PHONE.
           MOVE SPACES TO CUS-EMAIL.

       P-DISPLAY-DATA.
           MOVE CUS-NUMBER TO CUS-NUMBER-T
           DISPLAY CUS-NUMBER-T LINE  9 POSITION  23 LOW.
           MOVE CUS-NAME-1 TO CUS-NAME-1-T
           DISPLAY CUS-NAME-1-T LINE  10 POSITION  23 LOW.
           MOVE CUS-NAME-2 TO CUS-NAME-2-T
           DISPLAY CUS-NAME-2-T LINE  10 POSITION  45 LOW.
           MOVE CUS-COMPANY TO CUS-COMPANY-T
           DISPLAY CUS-COMPANY-T LINE  11 POSITION  23 LOW.
           MOVE CUS-ADDRESS-1 TO CUS-ADDRESS-1-T
           DISPLAY CUS-ADDRESS-1-T LINE  12 POSITION  23 LOW.
           MOVE CUS-ADDRESS-2 TO CUS-ADDRESS-2-T
           DISPLAY CUS-ADDRESS-2-T LINE  13 POSITION  23 LOW.
           MOVE CUS-CITY TO CUS-CITY-T
           DISPLAY CUS-CITY-T LINE  14 POSITION  23 LOW.
           MOVE CUS-STATE TO CUS-STATE-T
           DISPLAY CUS-STATE-T LINE  15 POSITION  23 LOW.
           MOVE CUS-ZIP TO CUS-ZIP-T
           DISPLAY CUS-ZIP-T LINE  15 POSITION  44 LOW.
           MOVE CUS-PHONE TO CUS-PHONE-T
           DISPLAY CUS-PHONE-T LINE  16 POSITION  23 LOW.
           MOVE CUS-EMAIL TO CUS-EMAIL-T
           DISPLAY CUS-EMAIL-T LINE  17 POSITION  23 LOW.
 
       P-CLEAR-SCREEN.
           DISPLAY ALL SPACES SIZE 18 LINE  10 POSITION  23
           DISPLAY ALL SPACES SIZE 17 LINE  10 POSITION  45
           DISPLAY ALL SPACES SIZE 25 LINE  11 POSITION  23
           DISPLAY ALL SPACES SIZE 25 LINE  12 POSITION  23
           DISPLAY ALL SPACES SIZE 25 LINE  13 POSITION  23
           DISPLAY ALL SPACES SIZE 25 LINE  14 POSITION  23
           DISPLAY ALL SPACES SIZE 2 LINE  15 POSITION  23
           DISPLAY ALL SPACES SIZE 5 LINE  15 POSITION  44
           DISPLAY ALL SPACES SIZE 17 LINE  16 POSITION  23
           DISPLAY ALL SPACES SIZE 40 LINE  17 POSITION  23.
       DISPLAY-SCREEN.
            DISPLAY " " ERASE
           DISPLAY "["
            LINE 25 POSITION 1 LOW .
           DISPLAY "A"
            LINE 25 POSITION 2 HIGH.
           DISPLAY "]dd ["
            LINE 25 POSITION 3 LOW .
           DISPLAY "M"
            LINE 25 POSITION 8 HIGH.
           DISPLAY "]odify ["
            LINE 25 POSITION 9 LOW .
           DISPLAY "D"
            LINE 25 POSITION 17 HIGH.
           DISPLAY "]elete ["
            LINE 25 POSITION 18 LOW .
           DISPLAY "F"
            LINE 25 POSITION 26 HIGH.
           DISPLAY "]irst ["
            LINE 25 POSITION 27 LOW .
           DISPLAY "N"
            LINE 25 POSITION 34 HIGH.
           DISPLAY "]ext ["
            LINE 25 POSITION 35 LOW .
           DISPLAY "Q"
            LINE 25 POSITION 41 HIGH.
           DISPLAY "]uery ["
            LINE 25 POSITION 42 LOW .
           DISPLAY "E"
            LINE 25 POSITION 49 HIGH.
           DISPLAY "]nd"
            LINE 25 POSITION 50 LOW .
           DISPLAY "" LINE  3 POSITION  4 LOW.
           DISPLAY "" LINE  3 POSITION  29 LOW.
           DISPLAY "Ŀ" LINE  3 POSITION  54 LOW.
           DISPLAY "                        " LINE  4 POSITION  4 LOW.
           DISPLAY "Example data Entry Form  " LINE  4 POSITION  29 LOW.
           DISPLAY "" LINE  4 POSITION  74 LOW.
           DISPLAY "                        " LINE  5 POSITION  4 LOW.
           DISPLAY "Customer Form            " LINE  5 POSITION  33 LOW.
           DISPLAY "" LINE  5 POSITION  74 LOW.
           DISPLAY "                        " LINE  6 POSITION  4 LOW.
           DISPLAY "" LINE  6 POSITION  74 LOW.
           DISPLAY "" LINE  7 POSITION  4 LOW.
           DISPLAY "" LINE  7 POSITION  29 LOW.
           DISPLAY "͵" LINE  7 POSITION  54 LOW.
           DISPLAY "                        " LINE  8 POSITION  4 LOW.
           DISPLAY "" LINE  8 POSITION  74 LOW.
           DISPLAY "  Id Num.       :[" LINE  9 POSITION  4 LOW.
           DISPLAY "]                        " LINE  9 POSITION  31 LOW.
           DISPLAY "" LINE  9 POSITION  74 LOW.
           DISPLAY "  Name(s)       :[" LINE  10 POSITION  4 LOW.
           DISPLAY "][" LINE  10 POSITION  43 LOW.
           DISPLAY "]         " LINE  10 POSITION  64 LOW.
           DISPLAY "  Company       :[" LINE  11 POSITION  4 LOW.
           DISPLAY "]                       " LINE  11 POSITION  50 LOW.
           DISPLAY "  Address       :[" LINE  12 POSITION  4 LOW.
           DISPLAY "]                       " LINE  12 POSITION  50 LOW.
           DISPLAY "                 [" LINE  13 POSITION  4 LOW.
           DISPLAY "]                       " LINE  13 POSITION  50 LOW.
           DISPLAY "  City          :[" LINE  14 POSITION  4 LOW.
           DISPLAY "]                       " LINE  14 POSITION  50 LOW.
           DISPLAY "  State         :[" LINE  15 POSITION  4 LOW.
           DISPLAY "]     Zip Code :[" LINE  15 POSITION  27 LOW.
           DISPLAY "]                      " LINE  15 POSITION  51 LOW.
           DISPLAY "  Phone         :[" LINE  16 POSITION  4 LOW.
           DISPLAY "]                        " LINE  16 POSITION  42 LOW.
           DISPLAY "" LINE  16 POSITION  74 LOW.
           DISPLAY "  Email         :[" LINE  17 POSITION  4 LOW.
           DISPLAY "" LINE  17 POSITION  74 LOW.
           DISPLAY "                        " LINE  18 POSITION  4 LOW.
           DISPLAY "" LINE  18 POSITION  74 LOW.
           DISPLAY "                        " LINE  19 POSITION  4 LOW.
           DISPLAY "" LINE  19 POSITION  74 LOW.
           DISPLAY "" LINE  20 POSITION  4 LOW.
           DISPLAY "" LINE  20 POSITION  29 LOW.
           DISPLAY "" LINE  20 POSITION  54 LOW.
           DISPLAY "" LINE  21 POSITION  1 LOW.
           DISPLAY "" LINE  21 POSITION  26 LOW.
           DISPLAY "" LINE  21 POSITION  51 LOW.
           DISPLAY "" LINE  21 POSITION  76 LOW.
*                             
